package com.example.aeropuertoback.controller;

import com.example.aeropuertoback.entity.AgenteReserva;
import com.example.aeropuertoback.service.agente.IAgenteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/agentes")
@CrossOrigin(origins = "http://localhost:4200")
public class AgenteController {
    @Autowired
    private IAgenteService agenteService;

    @GetMapping(value = "/listar")
    public List<AgenteReserva> listar(){
        return agenteService.findAll();
    }

    @PostMapping(value = "/agregar")
    public AgenteReserva guardarPasajero(@RequestBody AgenteReserva agenteReserva){
        return agenteService.save(agenteReserva);
    }

    @PutMapping(value = "/actualizar/{id}")
    public AgenteReserva actualizarPasajero(@PathVariable Integer id, @RequestBody AgenteReserva agenteReserva){
        AgenteReserva editarAgente = agenteService.findOne(id);
        agenteReserva.setId(editarAgente.getId());
        agenteReserva.setAgenteAuth(editarAgente.getAgenteAuth());
        return agenteService.save(agenteReserva);
    }

    @GetMapping(value = "/byId/{id}")
    public AgenteReserva listarPorId(@PathVariable Integer id){
        return agenteService.findOne(id);
    }

    @DeleteMapping(value="/eliminar/{id}")
    public void aliminarAgente(@PathVariable Integer id) {
        agenteService.delete(id);
    }
}
