package com.example.aeropuertoback.controller;

import com.example.aeropuertoback.entity.AgenteReserva;
import com.example.aeropuertoback.entity.ItinerarioReserva;
import com.example.aeropuertoback.entity.Pago;
import com.example.aeropuertoback.entity.Pasajero;
import com.example.aeropuertoback.service.agente.IAgenteService;
import com.example.aeropuertoback.service.itinerario.IItinerarioService;
import com.example.aeropuertoback.service.pasajero.IPasajeroService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@CrossOrigin(origins = "http://localhost:4200")
@RestController
@RequestMapping(value = "/itinerarios")
public class ItinerarioReservaController {

    @Autowired
    private IItinerarioService itinerarioService;

    @Autowired
    private IPasajeroService iPasajeroService;

    @Autowired
    private IAgenteService iAgenteService;

    @GetMapping(value = "/listar")
    public List<ItinerarioReserva> listar(){
        return itinerarioService.findAll();
    }

    @PostMapping(value = "/agregar")
    public ItinerarioReserva guardarItinerario(@RequestBody ItinerarioReserva itinerarioReserva){
        Pasajero pasajero = iPasajeroService.findOne(itinerarioReserva.getPasajero().getId());
        AgenteReserva agenteReserva = iAgenteService.findOne(itinerarioReserva.getAgente().getId());

        itinerarioReserva.setPasajero(pasajero);
        itinerarioReserva.setAgente(agenteReserva);
        return itinerarioService.save(itinerarioReserva);
    }

    @PutMapping(value = "/actualizar/{id}")
    public ItinerarioReserva actualizarReserva(@PathVariable Integer id, @RequestBody ItinerarioReserva itinerarioReservaDeta){
        ItinerarioReserva editReserva= itinerarioService.findOne(id);
        editReserva.setEstado(itinerarioReservaDeta.getEstado());
        return itinerarioService.save(editReserva);
    }


    @GetMapping("listar/{id}/pagos")
    public List<Pago> listarFiestasDeLaPersona(@PathVariable Integer id){
        ItinerarioReserva itinerarioReserva = itinerarioService.findOne(id);

      return itinerarioReserva.getPagos();
    }

    @GetMapping(value = "/byId/{id}")
    public ItinerarioReserva listarPorId(@PathVariable Integer id){
        return itinerarioService.findOne(id);
    }

    @GetMapping(value = "/pasajero/{id}")
    public List<ItinerarioReserva> listarReservaPorPasajeroId(@PathVariable Integer id){
        return iPasajeroService.findOne(id).getItinerarioReservas();

    }
}
