package com.example.aeropuertoback.controller;

import com.example.aeropuertoback.dao.ItinerarioRepository;
import com.example.aeropuertoback.dao.PagoRepository;
import com.example.aeropuertoback.entity.Pago;
import com.example.aeropuertoback.service.pago.IPagoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@CrossOrigin(origins = "http://localhost:4200")
@RestController
@RequestMapping(value = "/pagos")
public class PagoController {

    @Autowired
    private IPagoService pagoService;

    @Autowired
    private PagoRepository pagoRepository;

    @Autowired
    private ItinerarioRepository itinerarioRepository;


    @GetMapping(value = "/listar")
    public List<Pago> listar(){
        return pagoService.findAll();
    }

    @PostMapping(value = "/agregar", consumes = MediaType.APPLICATION_JSON_VALUE)
    public Pago guardarPasajero(@RequestBody Pago pago){
        return pagoService.save(pago);
    }

    @GetMapping(value = "/byId/{id}")
    public Pago listarPorId(@PathVariable Integer id){
        return pagoService.findOne(id);
    }

    @GetMapping("/reservas/{id}/pagos")
    public List<Pago> getAllPagosByReservaId(@PathVariable(value = "id") Integer id) {

        List<Pago> PagoA = pagoRepository.findPagosByItinerarioReservaId(id);
        return PagoA;
    }

    @DeleteMapping(value="/eliminar/{id}")
    public void eliminarPasajero(@PathVariable Integer id){
        pagoService.delete(id);
    }

    @PostMapping("/reservas/{id}/pagos")
    public Pago addTag(@PathVariable(value = "id") Integer id, @RequestBody Pago pagoRequest) {
        Pago pago = itinerarioRepository.findById(id).map(itinerarioReserva -> {
            Integer pagoId = pagoRequest.getId();
            Pago _pag = pagoRepository.findById(pagoId).orElseThrow(null);
            itinerarioReserva.addPago(_pag);
            itinerarioRepository.save(itinerarioReserva);
            return _pag;

        }).orElseThrow(null);

        return pago;
    }
}
