package com.example.aeropuertoback.controller;

import com.example.aeropuertoback.entity.*;
import com.example.aeropuertoback.service.aeropuerto.IAeropuertoService;
import com.example.aeropuertoback.service.vuelo.IVueloService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import java.util.List;

@CrossOrigin(origins = "http://localhost:4200")
@RestController
@RequestMapping(value = "/vuelos")
public class VueloController {

    @Autowired
    private IVueloService vueloService;

    @Autowired
    private IAeropuertoService aeropuertoService;

    @GetMapping(value = "/listar")
    public List<Vuelo> listar(){
        return vueloService.findAll();
    }

    @PostMapping(value = "/agregar", consumes = MediaType.APPLICATION_JSON_VALUE)
    public Vuelo guardarVuelo(@RequestBody Vuelo vuelo){
        Aeropuerto aeropuertoOrigen = aeropuertoService.findOne(vuelo.getCodigoAeropuertoOrigen().getId());
        Aeropuerto aeropuertoDestino = aeropuertoService.findOne(vuelo.getCodigoAeropuertoDestino().getId());
        vuelo.setCodigoAeropuertoOrigen(aeropuertoOrigen);
        vuelo.setCodigoAeropuertoDestino(aeropuertoDestino);
        return vueloService.save(vuelo);
    }

    @PutMapping(value = "/actualizar/{id}")
    public Vuelo actualizarVuelo(@PathVariable Integer id, @RequestBody Vuelo vuelo){
        Vuelo editarVuelo = vueloService.findOne(id);
        vuelo.setId(editarVuelo.getId());
        return vueloService.save(vuelo);
    }

    @GetMapping(value = "/byId/{id}")
    public Vuelo listarPorId(@PathVariable Integer id){
        return vueloService.findOne(id);
    }

    @DeleteMapping(value="/eliminar/{id}")
    public void eliminarVuelo(@PathVariable Integer id){
        vueloService.delete(id);
    }


}
