package com.example.aeropuertoback.service.pago;

import com.example.aeropuertoback.dao.IPagoDAO;
import com.example.aeropuertoback.dao.IVueloDAO;
import com.example.aeropuertoback.entity.Pago;
import com.example.aeropuertoback.entity.Vuelo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class PagoServiceImpl implements IPagoService {

    @Autowired
    private IPagoDAO pagoDAO;

    @Override
    @Transactional(readOnly=true)
    public List<Pago> findAll() {
        return (List<Pago>)pagoDAO.findAll();
    }

    @Transactional(readOnly=true)
    @Override
    public Pago findOne(Integer id) {
        return pagoDAO.findById(id).orElse(null);
    }

    @Override
    public Pago save(Pago pago) {
        return pagoDAO.save(pago);
    }

    @Override
    public void delete(Integer id) {
        pagoDAO.deleteById(id);
    }

    @Override
    public List<Pago> findPagosByItinerarioReserva(Integer id) {
        return pagoDAO.findPagosByItinerarioReserva(id);
    }
}
